//: ## Потік керування
//:
//: Вживайте `if` та `switch` щоб створювати умови. Вживайте `for`-`in`, `for`, `while`, та `repeat`-`while` щоб створювати цикли. Круглі дужки довкола виразу в умовах та циклах необов’язкові. Фігурні дужки довкола тіла обов’язкові.
//:
let individualScores = [75, 43, 103, 87, 12]
var teamScore = 0
for score in individualScores {
    if score > 50 {
        teamScore += 3
    } else {
        teamScore += 1
    }
}
print(teamScore)

//: Умова у конструкції `if` повинна бути Булевим виразом — тобто код на кшталт `if score { ... }` є помилкою, а не неявним порівнянням з нулем.
//: Ви можете використовувати `if` та `let` разом щоб працювати зі значеннями, що можуть бути відсутніми. Ці значення представлені як опціонали. Опціонал містить або значення, або `nil` щоб зазначити відсутність значення. Щоб зробити значення опціональним, напишіть після його типу знак питання (`?`).
//:
var optionalString: String? = "Hello"
print(optionalString == nil)

var optionalName: String? = "John Appleseed"
var greeting = "Hello!"
if let name = optionalName {
    greeting = "Hello, \(name)"
}

//: - Experiment:
//: Присвойте `optionalName` значення `nil`. Яке вітання ви отримуєте? Додайте секцію `else`, котра задає інше вітання, якщо `optionalName` є `nil`.
//:
//: Якщо значення опціоналу `nil`, то умова вважається хибною (`false`) і код у фігурних дужках пропускається. В іншому випадку значення опціоналу розгортається і присвоюється константі після `let`, що робить розгорнуте значення доступним всередині блоку коду.
//:
//: Іншим способом працювати з опціоналами є надання значення за замовчуванням за допомогою оператору `??`. Якщо значення опціоналу відсутнє, замість нього використовується значення за замовчуванням.
//:
let nickName: String? = nil
let fullName: String = "John Appleseed"
let informalGreeting = "Hi \(nickName ?? fullName)"

//: Перемикачі  підтримують будь який тип данних і широке різноманіття операцій порівняння - вони не обмежені цілими числами і перевірками на рівність.
//:
let vegetable = "red pepper"
switch vegetable {
case "celery":
    print("Add some raisins and make ants on a log.")
case "cucumber", "watercress":
    print("That would make a good tea sandwich.")
case let x where x.hasSuffix("pepper"):
    print("Is it a spicy \(x)?")
default:
    print("Everything tastes good in soup.")
}

//: - Experiment:
//: Спробуйте прибрати випадок за замовчування. Яку помилку ви отримаєте?
//:
//: Помітьте як `let` може бути вжито в шаблоні для того, щоб присвоїти значення, що відповідає шаблону, константі.
//:
//: Після виконання коду всередині випадку `case`, що підійшов, програма виходить з перемикача `switch`. Виконання не переходить до наступного випадку `case`, тому нема необхідності явно виходити із перемикача оператором `break` в кінці кожного випадку.
//:
//: Щоб перебирати елементи в асоціативному масиві, вживайте `for`-`in`, надаючи пару імен для кожної пари ключ-значення. Асоціативні масиви є невпорядкованою колекцією, тому їх ключі і значення перебираються у довільному порядку.
//:
let interestingNumbers = [
    "Prime": [2, 3, 5, 7, 11, 13],
    "Fibonacci": [1, 1, 2, 3, 5, 8],
    "Square": [1, 4, 9, 16, 25],
]
var largest = 0
for (kind, numbers) in interestingNumbers {
    for number in numbers {
        if number > largest {
            largest = number
        }
    }
}
print(largest)

//: - Experiment:
//: Додайте іншу змінну, щоб відслідкувати, який вид чисел мав найбільше число.
//:
//: Вживайте `while` щоб повторювати блок коду допоки значення умови не зміниться на `false`. Умова циклю можу бути вказана в кінці, щоб бути певним що цикл виконається хоча б один раз.
//:
var n = 2
while n < 100 {
    n = n * 2
}
print(n)

var m = 2
repeat {
    m = m * 2
} while m < 100
print(m)

//: Ви можете тримати індекс в циклі, вживаючи `..<` для створення діапазону індексів.
//:
var total = 0
for i in 0..<4 {
    total += i
}
print(total)

//: Вживайте `..<` щоб створити діапазон, що не включає верхнє значення. Вживайте `...` для діапазонів, що включають верхнє і нижнє значення.
//:


//: [Назад](@previous) | [Далі](@next)
